package main

func generate(numRows int) [][]int {
	res := make([][]int, 0)
	for i := 0; i < numRows; i++ {
		res = append(res, make([]int, i+1))
		for j := 0; j < i+1; j++ {
			if j == 0 || j == i {
				res[i][j] = 1
				continue
			}
			res[i][j] = res[i-1][j-1] + res[i-1][j]
		}
	}
	return res
}

// func main() {
// 	fmt.Println(generate(30))
// }
