func findRestaurant(list1 []string, list2 []string) []string {
	res := make([]string, 0)
	min := len(list1) + len(list2)
	m := make(map[string]int)
	for i, s := range list1 {
		m[s] = i
	}
	for i, s := range list2 {
		if val, ok := m[s]; ok {
			if sum := val + i; sum < min {
				min = sum
				res = []string{s}
			} else if sum == min {
				res = append(res, s)
			}
		}
	}
	return res
}
