package main

// O(k) space usage
func getRow(rowIndex int) []int {
	res := [2][]int{make([]int, rowIndex+1), make([]int, rowIndex+1)}
	for i := 0; i < rowIndex+1; i++ {
		for j := 0; j < i+1; j++ {
			if j == 0 || i == j {
				res[i&1][j] = 1
				continue
			}
			res[i&1][j] = res[i&1^1][j-1] + res[i&1^1][j]
		}
	}
	return res[rowIndex&1]
}

// func main() {
// 	fmt.Println(getRow(3))
// }
