'use strict'

/**
 * @param {number} n - a positive integer
 * @return {number}
 */
var hammingWeightOld = function (n) {
    let res = 0
    for (let i = 0; i < 32; i++) {
        res += n & 1
        n >>= 1
    }
    return res
}

// simple solution using built-in
var hammingWeight = function (n) {
    return (n).toString(2).replace(/0/g, '').length
}

function __main__() {
    /*eslint no-console: ["error", { allow: ["log"] }] */
    console.log(hammingWeight(0xFFFFFFFF))
    console.log(hammingWeightOld(0xFFFFFFFF))
}

__main__()