func convertToBase7(num int) string {
	if num == 0 {
		return "0"
	}
	str := make([]rune, 0)
	isNeg := false
	if num < 0 {
		isNeg = true
		num = -num
	}
	for num != 0 {
		str = append(str, rune(num%7+'0'))
		num /= 7
	}
	for l, r := 0, len(str)-1; l < r; l, r = l+1, r-1 {
		str[l], str[r] = str[r], str[l]
	}
	if isNeg {
		return "-" + string(str)
	}
	return string(str)
}
